//---------------------------------------------------------------------------
#include <windows.h>
#pragma hdrstop

#include <cstring>
#include <sstream>
#include <iomanip>
#include <gimite/temp_array.h>
#include "Win32Common.h"
using namespace std;
using namespace gimite;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
std::wstring SjisToUtf16(const std::string& s)//S-JISUTF-16ɕϊ
{
	temp_array<wchar_t> wcs(s.length()+1);
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, s.c_str(), -1,
		wcs.get(), s.length()+1);
	return wcs.get();
}

//---------------------------------------------------------------------------
std::string Utf16ToSjis(const std::wstring& ws)//UTF-16S-JISɕϊ
{
	temp_array<char> cs(ws.length()*2+1);
	WideCharToMultiByte(CP_ACP, 0, ws.c_str(), -1, cs.get(), ws.length()*2+1,
		NULL, NULL);
	return cs.get();
}

//---------------------------------------------------------------------------
std::string BytesToStr(int bytes)//oCgKBAMBȂǂgĕ
{
	const char* sUnit[]= {"oCg", "KB", "MB", "GB", "TB"};
	int i;
	double n= bytes;
	for (i= 0; i<4; ++i){
		if (n<1024) break;
		n/= 1024;
	}
	ostringstream ss;
	if (n>=100 || i==0) ss<<int(n);
	else ss<<showpoint<<setw(3)<<setprecision(3)<<n;
	return ss.str()+sUnit[i];
}

//---------------------------------------------------------------------------
void DevideCommandLine(const char* csCmd, vector<string>& ssArg)
	//R}hCg[N
{
	const char* cp= csCmd;
	ssArg.clear();
	while (*cp){
		string s;
		for (;*cp && isspace(*cp);++cp);
		if (!*cp) break;
		if (*cp=='\"'){
			for (++cp;*cp;++cp){
				if (*cp=='\"'){
					++cp;
					if (*cp!='\"') break;
				}
				s+= *cp;
			}
		}else{
			for (;*cp && !isspace(*cp);++cp)
				s+= *cp;
		}
		ssArg.push_back(s);
	}
}

//---------------------------------------------------------------------------
TPathKind GetPathKind(const std::string& path)//pX̎ނ𔻕
{
	DWORD fa= GetFileAttributes(path.c_str());
	if (fa==0xffffffff)
		return pkInvalid;
	else if (fa&FILE_ATTRIBUTE_DIRECTORY)
		return pkDir;
	else
		return pkFile;
}

//---------------------------------------------------------------------------

