//---------------------------------------------------------------------------
#include <cstring>//strchr
#include <iostream>//cin, cout
#include "arg_parser.h"
using namespace std;
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
arg_parser::arg_parser(int argc, char** argv, 
    const char* arg_options/*= ""*/, 
    char option_c/*= '-'*/, char out_option/*= 'o'*/)
  : out_option_(out_option)
{
  char prev_opt= '\0';
  for (int i= 1; i<argc; ++i){
    if (argv[i][0]==option_c){
      for (char* p= argv[i]+1; *p; ++p){
        char c= *p;
				opt_map_[c]= string();
				if (strchr(arg_options, c)){
					if (*(++p)) opt_map_[c]= p;
					else prev_opt= c;
					break;
				}
			}
		}else{
			if (prev_opt)
				opt_map_[prev_opt]= argv[i];
			else
				normal_args_.push_back(argv[i]);
			prev_opt= '\0';
		}
	}
}

//---------------------------------------------------------------------------
std::istream& arg_parser::in(){
  if (pin_.get()){
    return *pin_;
  }else if (normal_argc()>=1){
    pin_.reset(new ifstream(normal_argv(0).c_str()));
    return *pin_;
  }else{
    return std::cin;
  }
}

//---------------------------------------------------------------------------
std::ostream& arg_parser::out(){
  if (pout_.get()){
    return *pout_;
  }else if (has_option(out_option_)){
    pout_.reset(new ofstream(option_arg(out_option_).c_str()));
    return *pout_;
  }else{
    return std::cout;
  }
}

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
