//---------------------------------------------------------------------------
#ifndef BackupH
#define BackupH
//---------------------------------------------------------------------------
#include <boost/function.hpp>
#include <vector>
#include <string>
#include "Definitions.h"
#include "GTS.h"
//---------------------------------------------------------------------------
class TBackup;
//---------------------------------------------------------------------------
//obNAbv1P
class TBackupUnit: public gimite::TGTSObject
{
public:
	typedef std::vector<std::string> TStringVector;

	explicit TBackupUnit(TBackup* backup= NULL);
	void Backup(const TStringVector& paths);//obNAbv
	void Delete();//obNAbv폜
	DWORD FilesSize()const{return sizeFiles_;}
	TPosixTime Time()const{return time_;}
	std::string Name()const{return sName_;}
	std::string BaseDirPath()const{return pathBaseDir_;}

protected:
	//oǂݍ
	virtual void ReadMembers(gimite::TGTSNode* node);
	//o
	virtual void WriteMembers(gimite::TGTSNode* node)const;

private:
	TBackup* backup_;//e(UN)
	TPosixTime time_;//obNAbv
	std::string sName_;//obNAbv
	DWORD sizeFiles_;//St@C̍vTCY[oCg]
	TStringVector bpathsFile_;
		//obNAbvꂽt@C̃obNAbvpX(*1)
	std::string pathBaseDir_;//obNAbv̊tH_

	void MakeName(const TStringVector& paths);//O
	std::string BackupPath(const std::string& path);
		//̃pXɑΉobNAbvpX(*1)
	static void CreateDir(const std::string& path);
		//tH_Ƃ̑SĂ̑ctH_
	static bool RemoveDirAndSubDirs(const std::string& path);
		//tH_Ƃ̑SẴTutH_폜

};

//*1  "Backup\obNAbv"̑΃pX
//---------------------------------------------------------------------------
//obNAbv
class TBackup: public gimite::TGTSObject
{
public:
	typedef std::vector<std::string> TStringVector;
	typedef boost::function1<bool, std::vector<TBackupUnit*> > TOnQueryDelete;
	typedef boost::function1<bool, DWORD> TOnBackupExceedingUnit;

	TBackup();
	void Backup(const TStringVector& paths);//obNAbv
	std::string BaseDirPath()const//obNAbvtH_
		{ return pathBaseDir_; }
	DWORD MaxSize()const{return sizeMax_;}
	TTimeDuration DeletableTime()const{return tmdDeletable_;}
	void SetBaseDirPath(const std::string& s){pathBaseDir_= s;}
	void SetMaxSize(DWORD size){sizeMax_= size;}
	void SetDeletableTime(const TTimeDuration& tmd){tmdDeletable_= tmd;}
	void SetOnQueryDelete(TOnQueryDelete func){onQueryDelete_= func;}
	void SetOnBackupExceedingUnit(TOnBackupExceedingUnit func)
		{onBackupExceedingUnit_= func;}

protected:
	//oǂݍ
	virtual void ReadMembers(gimite::TGTSNode* node);
	//o
	virtual void WriteMembers(gimite::TGTSNode* node)const;

private:
	std::string pathBaseDir_;//obNAbvtH_
	std::vector<TBackupUnit> units_;//obNAbvP
	DWORD sizeMax_;//obNAbvTCY̏[oCg]
	TTimeDuration tmdDeletable_;
		//̊Ԃ߂폜\
	TOnQueryDelete onQueryDelete_;//̃obNAbv폜Ău
	TOnBackupExceedingUnit onBackupExceedingUnit_;
		//P̂ŏ𒴂TCỸobNAbvPʂobNAbv邩

	DWORD TotalSize()const;//SobNAbṽTCY̍v
	static DWORD FilesSize(const TStringVector& paths);
		//w̃t@C̃TCY̍v

};

//---------------------------------------------------------------------------
#endif
