//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <sstream>
#include <fstream>
#include <boost/cast.hpp>
#include <babel.h>
#include <gimite/string_algo.h>
#include <Clipbrd.hpp>
#include "PlaceList.h"
#include "MainForm.h"
#include "CopyResultForm.h"
using namespace std;
using namespace boost;
using namespace gimite;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmCopyResult *frmCopyResult;
//---------------------------------------------------------------------------
__fastcall TfrmCopyResult::TfrmCopyResult(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
std::string TfrmCopyResult::Escape(const std::string& s)
{
	string sR= str_replace_all_copy<char>(s, "\n", "");
	if (sR.find_first_of(",\"")!=string::npos)
		return "\""+str_replace_all_copy<char>(sR, "\"", "\"\"")+"\"";
	else
		return sR;
}

//---------------------------------------------------------------------------
void __fastcall TfrmCopyResult::btnCopyOrSaveClick(TObject *Sender)
{
	Screen->Cursor= crHourGlass;//v
	babel::init_babel();
	const TAbstractPlaceList* list= frmMain->DevasApp()->PlaceList();
	int ct= list->PlaceCount();
	bool bMB= frmMain->DevasApp()->FileSet()->MultiByte();
	bool bFile= chkFile->Checked;
	bool bLine= chkLine->Checked;
	bool bHit= chkHit->Checked;
	bool bFowFol= chkFowFol->Checked;
	int lenFowFol= StrToIntDef(edtFowFolLen->Text, 30);
	if (lenFowFol<0) lenFowFol= 30;
	ostringstream ss;
	if (bFile) ss << "t@C,";
	if (bLine) ss << "s,";
	if (bFowFol) ss << "O̕,";
	if (bHit) ss << "qbg,";
	if (bFowFol) ss << "̕,";
	ss << "\r\n";
	for (int i= 0; i<ct; ++i){
		const TAbstractPlace* place= list->Place(i);
    if (!place->Selected()) continue;
      //`FbNĂӏ̂
		string sPrev, sNext;
		if (bFowFol){
			if (bMB){
				const TPlace<wchar_t>* wplace=
					polymorphic_downcast<const TPlace<wchar_t>*>(place);
				wstring wsPrev= wplace->PreviousTstr();
				if (wsPrev.length()>lenFowFol)
					wsPrev= wsPrev.substr(wsPrev.length()-lenFowFol);
				sPrev= babel::unicode_to_sjis(wsPrev);
				sNext= babel::unicode_to_sjis(
					wplace->NextTstr().substr(0, lenFowFol));
			}else{
				const TPlace<char>* cplace=
					polymorphic_downcast<const TPlace<char>*>(place);
				sPrev= cplace->PreviousTstr();
				if (sPrev.length()>lenFowFol)
					sPrev= sPrev.substr(sPrev.length()-lenFowFol);
				sNext= cplace->NextTstr().substr(0, lenFowFol);
			}
			string::size_type posPrev= sPrev.find_last_of('\n');
			if (posPrev!=string::npos) sPrev= sPrev.substr(posPrev+1);
			sNext= sNext.substr(0, sNext.find_first_of('\n'));
		}
		if (bFile) ss << Escape(frmMain->RelativePath(place->Path())) << ",";
		if (bLine) ss << place->LineNumber()+1 << ",";
		if (bFowFol) ss << Escape(sPrev) << ",";
		if (bHit) ss << Escape(place->Str()) << ",";
		if (bFowFol) ss << Escape(sNext) << ",";
		ss << "\r\n";
	}
  if (Sender==btnSave){
    if (!dlgSave->Execute()) return;
    ofstream fs(dlgSave->FileName.c_str(), ios::binary);
    fs << ss.str();
  }else{
  	Clipboard()->AsText= ss.str().c_str();
  }
	Screen->Cursor= crDefault;//v߂
	ModalResult= mrOk;
}
//---------------------------------------------------------------------------

