//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <iostream>
#include <gimite/reg_manager.h>
#include "Win32Common.h"
#include "Definitions.h"
using namespace std;
using namespace boost::posix_time;
using namespace boost::gregorian;
using namespace gimite;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
istream& operator>>(istream& is, TSearchMode& mode)
{
	string s;
	if (is>>s){
		if (s=="Normal") mode= smNormal;
		else if (s=="Word") mode= smWord;
		else if (s=="Regex") mode= smRegex;
		else is.setstate(ios::badbit);
	}
	return is;
}

ostream& operator<<(ostream& os, TSearchMode mode)
{
	switch (mode){
		case smNormal: os<<"Normal"; break;
		case smWord: os<<"Word"; break;
		case smRegex: os<<"Regex"; break;
    default: assert(false);
	}
	return os;
}

//---------------------------------------------------------------------------
std::string IncludingDir(const std::vector<std::string>& paths)
	//St@C܂ރfBNg
{
	if (paths.empty()){
		return "";
	}else{
		string pathDir;
		string::size_type pos;
		for (pos= 0; ; ++pos){
			size_t i;
			char c= '\0';
			for (i= 0; i<paths.size(); ++i){
				if (pos>=paths[i].length()) break;
				if (!c) c= paths[i][pos];
				else if (c!=paths[i][pos]) break;
			}
			if (i<paths.size()) break;
		}
		pathDir= paths[0].substr(0, pos);
    string pathDir2= ExcludeTrailingPathDelimiter(pathDir.c_str()).c_str();
    if (pathDir!=pathDir2) //pathDir̖'\\'
      return pathDir2;
    else
      return ExtractFileDir(pathDir.c_str()).c_str();
  }
}

//---------------------------------------------------------------------------
std::string RelativePath(const std::string& path,
		const std::string& pathBase)
	//pathBaseƂpath̑΃pX߂
{
	if (pathBase.empty()) return path;
	string pathBase2= IncludeTrailingPathDelimiter(pathBase.c_str()).c_str();
	if (path.length()>=pathBase2.length())
		return path.substr(pathBase2.length());
	else
		return path;
}

//---------------------------------------------------------------------------
TStringVector Tokenize(const std::string& s)
  //Xy[Xŕi" "ł̃NI[gɑΉj
{
  reg_manager rm;
  TStringVector tokens;
  if (rm.search(s,
        "\\G\\s*((\"((\"\"|[^\"])+)\")|([^\\s\"]+))", "g")){
    do{
      string token= rm.position(3) >= 0 ?
        rm.substitute(rm.str(3), "\"\"", "\"", "g") :
        rm.str(5);
      tokens.push_back(token);
    } while (rm.next());
  }
  return tokens;
}

//---------------------------------------------------------------------------
TPosixTime SystemTimeToPTime(const SYSTEMTIME& stime)
	//SYSTEMTIMEptimeɕϊ
{
	return ptime(date(stime.wYear, stime.wMonth, stime.wDay),
		time_duration(stime.wHour, stime.wMinute, stime.wSecond));
}

//---------------------------------------------------------------------------
std::string PTimeToJapanese(const TPosixTime& time)
	//ptime"yyyyNmd h:nn:ss"\Lɕϊ
{
	ostringstream ss;
	ss<<setfill('0')<<setw(4)<<time.date().year()<<"N"
		<<setw(1)<<time.date().month()<<""
		<<setw(1)<<time.date().day()<<" "
		<<setw(1)<<time.time_of_day().hours()<<":"
		<<setw(2)<<time.time_of_day().minutes()<<":"
		<<setw(2)<<time.time_of_day().seconds();
	return ss.str();
}

//---------------------------------------------------------------------------
TPosixTime GetFileLastWriteTime(const std::string& path)
  //t@C̍ŏIXV擾B
{
  HANDLE h= CreateFile(path.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL,
    OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
  FILETIME ftime;
  GetFileTime(h, NULL, NULL, &ftime);
  CloseHandle(h);
  SYSTEMTIME stime;
  FileTimeToSystemTime(&ftime, &stime);
  return SystemTimeToPTime(stime);
}

//---------------------------------------------------------------------------
std::istream& operator>>(std::istream& is, TPosixTime& time)
{
	string s;
	time_duration tmd;
	if (is>>s>>tmd) time= ptime(from_string(s), tmd);
	return is;
}

//---------------------------------------------------------------------------
std::ostream& operator<<(std::ostream& os,
	const TPosixTime& time)
{
	os<<to_iso_extended_string(time.date())<<' '<<time.time_of_day();
	return os;
}

//---------------------------------------------------------------------------
std::istream& operator>>(std::istream& is,
	TTimeDuration& time)
{
	string s;
	if (is>>s) time= duration_from_string(s);
	return is;
}

//---------------------------------------------------------------------------
std::ostream& operator<<(std::ostream& os,
	const TTimeDuration& time)
{
	os<<to_simple_string(time);
	return os;
}

//---------------------------------------------------------------------------

