//---------------------------------------------------------------------------
#ifndef OptionH
#define OptionH
//---------------------------------------------------------------------------
#include "GTS.h"
#include "SearchedPattern.h"
#include "File.h"
//---------------------------------------------------------------------------
//IvV
class TOption: public gimite::TGTSObject
{
public:
	TOption(): ccode_(ccAuto), mode_(smNormal), bSubDir_(false),
  	bCaseSensitive_(true), bEscape_(false), bByLine_(false),
		bShowLine_(true), bCheckCharCode_(true), bCheckTime_(true),
    sizeMaxFile_(50*1024*1024), sEditor_(""), bEditorDefault_(false),
    bBackup_(true){}

 	TCharCode CharCode()const{return ccode_;}
	TSearchMode Mode()const{return mode_;}
	bool SubDir()const{return bSubDir_;}
	bool CaseSensitive()const{return bCaseSensitive_;}
	bool Escape()const{return bEscape_;}
	bool ByLine()const{return bByLine_;}
	bool ShowLine()const{return bShowLine_;}
	bool CheckCharCode()const{return bCheckCharCode_;}
	bool CheckTime()const{return bCheckTime_;}
	int MaxFileSize()const{return sizeMaxFile_;}
	std::string Editor()const{return sEditor_;}
	bool EditorDefault()const{return bEditorDefault_;}
	bool Backup()const{return bBackup_;}

	void SetCharCode(TCharCode c){ccode_= c;}
	void SetMode(TSearchMode m){mode_= m;}
	void SetSubDir(bool b){bSubDir_= b;}
	void SetCaseSensitive(bool b){bCaseSensitive_= b;}
	void SetEscape(bool b){bEscape_= b;}
	void SetByLine(bool b){bByLine_= b;}
	void SetShowLine(bool b){bShowLine_= b;}
	void SetCheckCharCode(bool b){bCheckCharCode_= b;}
	void SetCheckTime(bool b){bCheckTime_= b;}
  void SetMaxFileSize(int i){sizeMaxFile_= i;}
	void SetEditor(std::string s){sEditor_= s;}
  void SetEditorDefault(bool b){bEditorDefault_= b;}
	void SetBackup(bool b){bBackup_= b;}

protected:
	//oǂݍ
	virtual void ReadMembers(gimite::TGTSNode* node);
	//o
	virtual void WriteMembers(gimite::TGTSNode* node)const;

private:
	TCharCode ccode_;//R[h
	TSearchMode mode_;//[h
	bool bSubDir_;//TutH_
	bool bCaseSensitive_;//Eʂ邩
	bool bEscape_;//GXP[vg
	bool bByLine_;//sPʌ
	bool bShowLine_;//sԍ\邩
	bool bCheckCharCode_;//R[h`FbN邩
  bool bCheckTime_;//^CX^v`FbN邩
  int sizeMaxFile_;//t@CTCY̏
  std::string sEditor_;//OGfB^NR}h
  bool bEditorDefault_;//_uNbNŃGfB^N
	bool bBackup_;//obNAbv邩

};

//---------------------------------------------------------------------------
#endif
