//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include "Option.h"
#include "MainForm.h"
#include "OptionForm.h"
#include "VCLCommon.h"
using namespace boost::posix_time;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmOption *frmOption;
//---------------------------------------------------------------------------
__fastcall TfrmOption::TfrmOption(TComponent* Owner)
		: TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TfrmOption::btnOkClick(TObject *Sender)
{
	TOption* opt= frmMain->DevasApp()->Option();
	opt->SetMode(TSearchMode(cmbMode->ItemIndex));
	opt->SetSubDir(chkSubDir->Checked);
	opt->SetByLine(chkByLine->Checked);
	opt->SetCaseSensitive(chkCaseSensitive->Checked);
	opt->SetEscape(chkEscape->Checked);
	opt->SetShowLine(chkShowLine->Checked);
	opt->SetCharCode(TCharCode(cmbCharCode->ItemIndex));
	opt->SetCheckCharCode(chkCheckCharCode->Checked);
	opt->SetCheckTime(chkCheckTime->Checked);
  opt->SetMaxFileSize(max(StrToIntDef(edtMaxFileSize->Text, 50), 1) * 1024*1024);
  opt->SetEditor(edtEditor->Text.c_str());
  opt->SetEditorDefault(chkEditorDefault->Checked);
	opt->SetBackup(chkBackup->Checked);
	TBackup* back= frmMain->DevasApp()->Backup();
	back->SetMaxSize(max(StrToIntDef(edtBackupMaxSize->Text, 10), 1)
		*1024*1024);
	int i= StrToIntDef(edtBackupDeletableDay->Text, 0);
	if (i<0 || i>365) i= 365;
	back->SetDeletableTime(hours(i*24));
	back->SetBaseDirPath(edtBackupDir->Text.c_str());
	ModalResult= mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOption::FormShow(TObject *Sender)
{
	TOption* opt= frmMain->DevasApp()->Option();
	cmbMode->ItemIndex= int(opt->Mode());
	chkSubDir->Checked= opt->SubDir();
	chkByLine->Checked= opt->ByLine();
	chkCaseSensitive->Checked= opt->CaseSensitive();
	chkEscape->Checked= opt->Escape();
	chkShowLine->Checked= opt->ShowLine();
	cmbCharCode->ItemIndex= int(opt->CharCode());
	chkCheckCharCode->Checked= opt->CheckCharCode();
	chkCheckTime->Checked= opt->CheckTime();
  edtMaxFileSize->Text= IntToStr(opt->MaxFileSize()/1024/1024);
	edtEditor->Text= opt->Editor().c_str();
  chkEditorDefault->Checked= opt->EditorDefault();
	chkBackup->Checked= opt->Backup();
	TBackup* back= frmMain->DevasApp()->Backup();
	edtBackupMaxSize->Text= IntToStr(back->MaxSize()/1024/1024);
	edtBackupDeletableDay->Text= IntToStr(back->DeletableTime().hours()/24);
	edtBackupDir->Text= back->BaseDirPath().c_str();
	cmbSeaTypeChange(NULL);
	chkByLineClick(NULL);
	chkBackupClick(NULL);
	pgcMain->ActivePage= tbsSearchReplace;
	cmbMode->SetFocus();
}
//---------------------------------------------------------------------------


void __fastcall TfrmOption::cmbSeaTypeChange(TObject *Sender)
{
	if (TSearchMode(cmbMode->ItemIndex)==smRegex){
		chkEscape->Checked= true;
		chkEscape->Enabled= false;
	}else{
		chkEscape->Enabled= true;
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmOption::chkByLineClick(TObject *Sender)
{
	if (chkByLine->Checked){
		chkShowLine->Checked= true;
		chkShowLine->Enabled= false;
	}else{
		chkShowLine->Enabled= true;
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmOption::chkBackupClick(TObject *Sender)
{
	bool b= chkBackup->Checked;
	edtBackupMaxSize->Enabled= b;
	edtBackupDeletableDay->Enabled= b;
	edtBackupDir->Enabled= b;
  btnBackupDir->Enabled= b;
}
//---------------------------------------------------------------------------


void __fastcall TfrmOption::btnBackupDirClick(TObject *Sender)
{
  AnsiString dirNew=
    SelectDir(Handle, "obNAbvtH_w肵ĂB",
      edtBackupDir->Text);
  if (dirNew!="") edtBackupDir->Text= dirNew;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOption::btnEditorClick(TObject *Sender)
{
  TStringVector ss= Tokenize(edtEditor->Text.c_str());
  dlgEditor->FileName= ss.empty() ? "" : ss[0].c_str();
  if (dlgEditor->Execute()){
    edtEditor->Text= AnsiString("\"") + dlgEditor->FileName + "\" \"%p\"";
  }
}
//---------------------------------------------------------------------------

