//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <algorithm>
#include <gimite/string_algo.h>
#include <gimite/reg_manager.h>
#include "Win32Common.h"
#include "DevasApp.h"
#include "MainForm.h"
#include "ConfirmForm.h"
#include "ViewForm.h"
#include "ResultForm.h"
#include "Internationalization.h"
#include "MultiLineEditForm.h"
using namespace std;
using namespace gimite;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmResult *frmResult;
//---------------------------------------------------------------------------
__fastcall TfrmResult::TfrmResult(TComponent* Owner)
		: TForm(Owner), nFocusPlace_(0), bPlaceFocusVisible_(false),
		nResizingPlaceColumn_(-1)
{
}
//---------------------------------------------------------------------------
void TfrmResult::SetGUITexts()//GUĨeLXgݒ
{
	Caption= texts[tiResultFormCaption];
	pnlCheck->Caption= texts[tiResultPlacesHeadReplace];
	pnlPos->Caption= texts[tiResultPlacesHeadPosition];
	pnlFile->Caption= texts[tiResultPlacesHeadFileName];
	pnlLine->Caption= texts[tiResultPlacesHeadLine];
	lblReplacing->Caption= texts[tiResultReplacingStr];
	btnConfirm->Caption= texts[tiResultConfirm];
	btnReplace->Caption= texts[tiResultReplace];
}

//---------------------------------------------------------------------------
void TfrmResult::SetPlaceFocus(int i)//ʒuI
{
 	int ct= pbxPlaces->Height/htPlaceLine_;
  if (i>=ct) i= max(ct-1, 0);
  else if (i<0) i= 0;
  if (i!=nFocusPlace_){
    int nBak= nFocusPlace_;
    nFocusPlace_= i;
    RedrawPlace(nBak, nBak+1);//ȎI
    if (bPlaceFocusVisible_) DrawPlaceFocus();
  }
  //Iʒu\悤ɃXN[
  if (nFocusPlace_*htPlaceLine_<scbPlaces->VertScrollBar->Position)
  	scbPlaces->VertScrollBar->Position= nFocusPlace_*htPlaceLine_;
  else if ((nFocusPlace_+1)*htPlaceLine_
  		>=scbPlaces->VertScrollBar->Position+scbPlaces->ClientHeight)
    scbPlaces->VertScrollBar->Position
    	= (nFocusPlace_+1)*htPlaceLine_-scbPlaces->ClientHeight;
}

//---------------------------------------------------------------------------
void TfrmResult::DrawPlaceFocus()//ʒuI`
{
  pbxPlaces->Canvas->DrawFocusRect(Rect(0, nFocusPlace_*htPlaceLine_,
    pbxPlaces->Width, (nFocusPlace_+1)*htPlaceLine_));
}

//---------------------------------------------------------------------------
void TfrmResult::SwitchPlaceSelect(int n)//ʒȗI𔽓]
{
	const TAbstractPlaceList* list= frmMain->DevasApp()->PlaceList();
	if (!list) return;
	if (n<list->PlaceCount())
		list->Place(n)->SetSelected(!list->Place(n)->Selected());
	bmCache_.reset(NULL);//ʒuXg\LbVNA
}

//---------------------------------------------------------------------------
void TfrmResult::SetAllSelect(bool b)//SđIorSđI
{
	const TAbstractPlaceList* list= frmMain->DevasApp()->PlaceList();
	if (!list) return;
	for (int i= 0; i<(list->PlaceCount()); ++i)
		list->Place(i)->SetSelected(b);
}

//---------------------------------------------------------------------------
void TfrmResult::OpenEditor(int nPlace)//OGfB^J
{
  string sCommand= frmMain->DevasApp()->Option()->Editor();
  if (sCommand==""){
    Application->MessageBox(
      "OGfB^w肳Ă܂BIvVŎw肵ĂB",
      "Devas", MB_OK | MB_ICONEXCLAMATION);
    return;
  }

	const TAbstractPlaceList* list= frmMain->DevasApp()->PlaceList();
	if (!list) return;
  const TAbstractPlace* place= list->Place(nPlace);
  sCommand= str_replace_all_copy(sCommand, string("%p"),
    place->Path());
  sCommand= str_replace_all_copy(sCommand, string("%l"),
    to_str(place->LineNumber()+1));
  sCommand= str_replace_all_copy(sCommand, string("%c"),
    to_str(place->Position()+1));

  reg_manager rm;
  string sArgs;
  if (rm.match(sCommand, "(\"(.*?)\"|([^\\s\"]+))\\s+(.*)")){
    sCommand= rm.str(2)+rm.str(3);
    sArgs= rm.str(4);
  }

  long r= (long)ShellExecute(Handle, NULL, sCommand.c_str(), sArgs.c_str(),
    NULL, SW_SHOWDEFAULT);

  string sError;
  if (r==ERROR_FILE_NOT_FOUND || r==ERROR_PATH_NOT_FOUND){
    sError= "OGfB^̃t@C܂̓pX܂B";
  }else if (r<=32){
    sError= "OGfB^JƂɃG[܂B";
  }
  if (sError!=""){
    Application->MessageBox(sError.c_str(), "Devas",
      MB_OK | MB_ICONEXCLAMATION);
  }
}

//---------------------------------------------------------------------------
void TfrmResult::OnPlacesUpdate(bool bAdd)//ʒuXgXVꂽ
{
	GIMITE_MAPROFILED("TfrmResult::OnPlacesUpdate");
	if (!bAdd) bmCache_.reset(NULL);//LbVNA
	const TAbstractPlaceList* list= frmMain->DevasApp()->PlaceList();
	int ct= list? list->PlaceCount() : 0;
	scbPlaces->Invalidate();
	pbxPlaces->Height= ct*htPlaceLine_;//pbxPlacesPaintĂ΂
	scbPlaces->Update();
	if (nFocusPlace_>=ct && nFocusPlace_!=0)
		SetPlaceFocus(max(ct-1, 0));//tH[JX𐳋K
	stbMain->Panels->Items[1]->Text= IntToStr(ct)+" ܂B";
}

//---------------------------------------------------------------------------
void TfrmResult::RedrawPlace(int nBegin, int nEnd)
  //[nBegin,nEnd)Ԗڂ̈ʒu̕\XV
{
	if (!bmCache_.get() || nBegin!=nCacheBegin_ || nEnd!=nCacheEnd_){
			//LbVgȂ

		static const string sCR= " ";//s\}[N
		int wtBox= pbxPlaces->ClientWidth;
		int xCheck= pnlCheck->Left;
		int wtCheck= pnlCheck->Width;
		int xPos= pnlPos->Left;
		int wtPos= pnlPos->Width;
		int xFile= pnlFile->Left;
		int wtFile= pnlFile->Width;
		int xLine= pnlLine->Left;
		int wtLine= pnlLine->Width;

		const TAbstractPlaceList* list= frmMain->DevasApp()->PlaceList();
		if (!list) return;
		nEnd= min(nEnd, list->PlaceCount());
		nBegin= min(nBegin, nEnd);
		assert(nBegin>=0);
		if (!bmCache_.get()) bmCache_.reset(new TGBitmap);
		bmCache_->Width= wtBox;
		bmCache_->Height= (nEnd-nBegin)*htPlaceLine_;
		nCacheBegin_= nBegin; nCacheEnd_= nEnd;
		TCanvas* cv= bmCache_->Canvas;
		cv->CopyMode= cmSrcCopy;
		cv->Brush->Style= bsSolid;
		cv->Brush->Color= clWindow;
		for (int i= nBegin; i<nEnd; ++i){
			const TAbstractPlace* place= list->Place(i);
			string s= str_replace_all_copy<char>(place->Str(), "\n", sCR);
			replace(s.begin(), s.end(), '\t', ' ');
			cv->FillRect(Rect(0, (i-nBegin)*htPlaceLine_,
				wtBox, (i-nBegin+1)*htPlaceLine_));
			cv->Font= cmbReplacing->Font;
			cv->Font->Style= TFontStyles()<<fsBold;
			int wtFound= cv->TextWidth(s.c_str());
			int xFound= xPos+(wtPos-wtFound)/2;
			DrawPlaceText(s, i, max(xFound, xPos), min(xFound+wtFound, xPos+wtPos),
				false);//`
			if (wtPos>wtFound){//̍Eɗ]
				cv->Font->Style= TFontStyles();
				string sPrev= place->PreviousStr();
				replace(sPrev.begin(), sPrev.end(), '\t', ' ');
				string::size_type posPrev= sPrev.find_last_of('\n');
				if (posPrev!=string::npos) sPrev= sPrev.substr(posPrev+1);
				DrawPlaceText(sPrev, i, xPos, xFound, true);//ʒȗO`
				string sNext= place->NextStr();
				replace(sNext.begin(), sNext.end(), '\t', ' ');
				sNext= sNext.substr(0, sNext.find_first_of('\n'));
				DrawPlaceText(sNext, i, xFound+wtFound, xPos+wtPos,
					false);//ʒǔ`
			}
			cv->Font= scbPlaces->Font;
			DrawPlaceText(frmMain->RelativePath(place->Path()), i, xFile,
				xFile+wtFile, false);
			if (frmMain->DevasApp()->Option()->ShowLine())
				DrawPlaceText(to_str(place->LineNumber()+1), i, xLine, xLine+wtLine,
					false);
			imlCheck->Draw(cv, xCheck+(wtCheck-imlCheck->Width)/2,
				(i-nBegin)*htPlaceLine_+(htPlaceLine_-imlCheck->Height)/2,
				place->Selected()? 1:0, true);
		}

	}
	pbxPlaces->Canvas->CopyMode= cmSrcCopy;
	pbxPlaces->Canvas->Draw(0, nBegin*htPlaceLine_, bmCache_.get());
		//LbV`
	if (bPlaceFocusVisible_ && nFocusPlace_>=nBegin && nFocusPlace_<nEnd)
		DrawPlaceFocus();//Ig`
}

//---------------------------------------------------------------------------
void TfrmResult::DrawPlaceText(const std::string& s, int nPlace, int xLeft,
		int xRight, bool bRight)
	//ʒuXg̃eLXg`
{
	assert(bmCache_.get());
	TRect rect(xLeft, (nPlace-nCacheBegin_)*htPlaceLine_,
		xRight, (nPlace-nCacheBegin_+1)*htPlaceLine_);
	DrawText(bmCache_->Canvas->Handle, s.c_str(), -1, &rect,
		DT_VCENTER|(bRight? DT_RIGHT:DT_LEFT)|DT_SINGLELINE|DT_NOPREFIX);
}

//---------------------------------------------------------------------------
void __fastcall TfrmResult::pbxPlacesPaint(TObject *Sender)
{
	TCanvas* cv= pbxPlaces->Canvas;
	int nBegin= cv->ClipRect.top/htPlaceLine_;
	int nEnd= cv->ClipRect.bottom/htPlaceLine_+1;
	RedrawPlace(nBegin, nEnd);
}

//---------------------------------------------------------------------------


void __fastcall TfrmResult::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	if (frmMain->State()==vsReplacable || frmMain->State()==vsUnreplacable)
		frmMain->SetState(vsReady);
  else
  	CanClose= false;
}
//---------------------------------------------------------------------------


void __fastcall TfrmResult::scbPlacesEnter(TObject *Sender)
{
	bPlaceFocusVisible_= true;
  DrawPlaceFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::scbPlacesExit(TObject *Sender)
{
	bPlaceFocusVisible_= false;
 	RedrawPlace(nFocusPlace_, nFocusPlace_+1);//I
}
//---------------------------------------------------------------------------


void __fastcall TfrmResult::edtPlacesDummyKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
	switch (Key){
		case VK_DOWN: SetPlaceFocus(nFocusPlace_+1); break;
		case VK_UP: SetPlaceFocus(nFocusPlace_-1); break;
		case VK_SPACE:
			SwitchPlaceSelect(nFocusPlace_);
			RedrawPlace(nFocusPlace_, nFocusPlace_+1);
			break;
  }
}
//---------------------------------------------------------------------------


void __fastcall TfrmResult::pbxPlacesMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	int n= Y/htPlaceLine_;
  SetPlaceFocus(n);
	edtPlacesDummy->SetFocus();

	if (Button==mbLeft){
		//`FbN{bNX̃NbNȂI𔽓]
		int xCheck= pnlCheck->Left;
		int wtCheck= pnlCheck->Width;
		int xCheckBox= xCheck+(wtCheck-imlCheck->Width)/2;
		int yCheckBox= n*htPlaceLine_+(htPlaceLine_-imlCheck->Height)/2;
		if (X>=xCheckBox && X<xCheckBox+imlCheck->Width
				&& Y>=yCheckBox && Y<yCheckBox+imlCheck->Height){
			SwitchPlaceSelect(n);
			RedrawPlace(n, n+1);
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::scbPlacesResize(TObject *Sender)
{
	pbxPlaces->Width= scbPlaces->ClientWidth;
}
//---------------------------------------------------------------------------


void __fastcall TfrmResult::btnReplaceClick(TObject *Sender)
{
	if (frmMain->State()==vsReplacable){
    if (Application->MessageBox(("XgŃ`FbNĂSĂ\n\""
        +frmMain->cmbSearched->Text+"\"\""+cmbReplacing->Text
        +"\"\nu܂B낵łH").c_str(), "Devas",
        MB_ICONEXCLAMATION|MB_YESNO
        |(cmbReplacing->Text==""? MB_DEFBUTTON2:MB_DEFBUTTON1))==IDYES){
    	frmMain->ComboBoxAddToHistory(cmbReplacing);
			frmMain->SetState(vsReplacing);
			frmMain->ClearSkips();
			TDevasApp* app= frmMain->DevasApp();
			TReplaceResult r= app->Replace(cmbReplacing->Text.c_str());
      if (r!=rrStopped) SetAllSelect(true);
			OnPlacesUpdate(false);
      if (!app->PlaceList() || app->PlaceList()->PlaceCount()==0){
        frmMain->SetState(vsReady);
      }else{
        frmMain->SetState(vsReplacable);
      }
      frmMain->OutputMessage(
        r==rrStopped ? "u𒆎~܂B" : "u܂B");
    }
  }
}

//---------------------------------------------------------------------------

void __fastcall TfrmResult::btnConfirmClick(TObject *Sender)
{
	TDevasApp* app= frmMain->DevasApp();
	if (!app->PlaceList()) return;
	int ct= app->PlaceList()->PlaceCount();
  frmConfirm->lsvConfirm->Items->Clear();
	for (int i= 0; i<ct; ++i){
    if (app->PlaceList()->Place(i)->Selected()){
      TListItem* item= frmConfirm->lsvConfirm->Items->Add();
      item->Caption= app->PlaceList()->Place(i)->Str().c_str();
			item->SubItems->Add(app->ReplacingStr(i, cmbReplacing->Text.c_str())
        .c_str());
    }
  }
  frmConfirm->ShowModal();
}
//---------------------------------------------------------------------------


void __fastcall TfrmResult::pnlPlacesHeadMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	int i;
	for (i= 0; i<ctPlaceColumn_-1; ++i){
		if (pnlsPlaceHead[i+1]->Left>=X) break;
	}
	nResizingPlaceColumn_= i;
	xPlaceColumnResize_= X;
	SetCapture(pnlPlacesHead->Handle);
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::FormCreate(TObject *Sender)
{
	assert(ctPlaceColumn_==4);
	pnlsPlaceHead[0]= pnlCheck;
	pnlsPlaceHead[1]= pnlPos;
	pnlsPlaceHead[2]= pnlFile;
	pnlsPlaceHead[3]= pnlLine;
	htPlaceLine_= pbxPlaces->Canvas->TextHeight("")+4;
	SetGUITexts();
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::pnlPlacesHeadMouseMove(TObject *Sender,
			TShiftState Shift, int X, int Y)
{
	if (nResizingPlaceColumn_<0) return;
	const int i= nResizingPlaceColumn_;
	int xOff= X-xPlaceColumnResize_;
	if (pnlsPlaceHead[i]->Width+xOff<wtPlaceColumnMin_
		|| pnlsPlaceHead[i+1]->Width-xOff<wtPlaceColumnMin_) return;
	pnlsPlaceHead[i]->Width= pnlsPlaceHead[i]->Width+xOff;
	pnlsPlaceHead[i+1]->Left= pnlsPlaceHead[i+1]->Left+xOff;
	pnlsPlaceHead[i+1]->Width= pnlsPlaceHead[i+1]->Width-xOff;
	xPlaceColumnResize_= X;
	OnPlacesUpdate(false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::pnlPlacesHeadMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (nResizingPlaceColumn_<0) return;
	ReleaseCapture();
	nResizingPlaceColumn_= -1;	
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::mniViewDblClick(TObject *Sender)
{
	TViewState state= frmMain->State();
	if (state==vsReplacable || state==vsUnreplacable){
    if (frmMain->DevasApp()->Option()->EditorDefault())
  		OpenEditor(nFocusPlace_);
    else
  		frmView->ShowPlace(nFocusPlace_);
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::pbxPlacesMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button==mbRight){
		TPoint pt= pbxPlaces->ClientToScreen(Point(X, Y));
		pmnPlaces->Popup(pt.x, pt.y);
	}
}
//---------------------------------------------------------------------------


void __fastcall TfrmResult::FormResize(TObject *Sender)
{
  btnReplacingEdit->Left= (pnlReplacing->Width)-(btnReplacingEdit->Width)-8;
	cmbReplacing->Width= (btnReplacingEdit->Left)-(cmbReplacing->Left)-8;
	//ʒuXg̐`
	//ȋ́uʒuv̗ɋ悤ɂj
	//iuʒuv̗ŏɂĂȂ΁A̗k߂j
	TPanel* pnlLast= pnlsPlaceHead[ctPlaceColumn_-1];
	int xOff= (pnlPlacesHead->Width)-((pnlLast->Left)+(pnlLast->Width));
	int wtPlaceColumn= pnlsPlaceHead[nPlacePlaceColumn_]->Width;
	if (wtPlaceColumn+xOff>=wtPlaceColumnMin_){
		pnlsPlaceHead[nPlacePlaceColumn_]->Width= wtPlaceColumn+xOff;
		for (int i= nPlacePlaceColumn_+1; i<ctPlaceColumn_; ++i)
			pnlsPlaceHead[i]->Left= (pnlsPlaceHead[i]->Left)+xOff;
	}else{
		int xRestMinus= wtPlaceColumnMin_-(wtPlaceColumn+xOff);
		int xCurOff= 0;
		for (int i= 0; i<ctPlaceColumn_; ++i){
			int xMinus;
			if (i==nPlacePlaceColumn_){
				xMinus= (pnlsPlaceHead[i]->Width)-wtPlaceColumnMin_;
			}else{
				xMinus=
					min(xRestMinus, (pnlsPlaceHead[i]->Width)-wtPlaceColumnMin_);
				xRestMinus-= xMinus;
			}
			pnlsPlaceHead[i]->Left= (pnlsPlaceHead[i]->Left)+xCurOff;
			pnlsPlaceHead[i]->Width= (pnlsPlaceHead[i]->Width)-xMinus;
			xCurOff-= xMinus;
		}
	}
	OnPlacesUpdate(false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
	scbPlaces->VertScrollBar->Position= scbPlaces->VertScrollBar->Position+16;
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::FormMouseWheelUp(TObject *Sender,
			TShiftState Shift, TPoint &MousePos, bool &Handled)
{
	scbPlaces->VertScrollBar->Position= scbPlaces->VertScrollBar->Position-16;
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::mniCopyPathClick(TObject *Sender)
{
	const TAbstractPlaceList* list= frmMain->DevasApp()->PlaceList();
	if (list && nFocusPlace_>=0 && nFocusPlace_<(list->PlaceCount())){
		string path= list->Place(nFocusPlace_)->Path();
		Clipboard()->AsText= path.c_str();
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::btnAllOnClick(TObject *Sender)
{
  SetAllSelect(true);
	OnPlacesUpdate(false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::btnAllOffClick(TObject *Sender)
{
	SetAllSelect(false);
	OnPlacesUpdate(false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::mniEditorClick(TObject *Sender)
{
  OpenEditor(nFocusPlace_);
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::btnReplacingEditClick(TObject *Sender)
{
  cmbReplacing->Text= TfrmMultiLineEdit::EditEscapedText(
    "u̕ҏW", cmbReplacing->Text.c_str()).c_str();  
}
//---------------------------------------------------------------------------

void __fastcall TfrmResult::pmnPlacesPopup(TObject *Sender)
{
  if (frmMain->DevasApp()->Option()->EditorDefault())
    mniEditor->Default= true;
  else
    mniView->Default= true;
}
//---------------------------------------------------------------------------

