//---------------------------------------------------------------------------
#ifdef GIMITE_MAPROF
//---------------------------------------------------------------------------
#include <stack>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include "Maprof.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
using namespace std;
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
TMaprof::~TMaprof()
{
  typedef TEvents::const_iterator TEventIt;

  double timeWhole= Clock()-timeBegin_;

  int lenMaxName= 6;
  for (TEventIt evit= events_.begin();
      evit!=events_.end(); ++evit)
    lenMaxName= max(lenMaxName, int(strlen(evit->csName_)));

  //Oo
  ofstream fsLog((sFile_+"_log.txt").c_str());
  for (TEventIt evit= events_.begin();
      evit!=events_.end(); ++evit){
    fsLog<<fixed<<setprecision(3)<<setw(8)<<right<<(evit->time_)
      <<' '<<setw(lenMaxName)<<left<<(evit->csName_)
      <<' '<<((evit->type_==etBegin)? "Begins.":"Ends.")<<endl;
  }

  //Ăяo֌W𕪐
  TInfoMap map_infos;
  TInfoMapMap map2_infos;
  stack<TCall> stk_call;
  stack<string> stk_sOper;
  for (TEventIt evit= events_.begin();
      evit!=events_.end(); ++evit){
    if (evit->type_==etBegin){
      if (!stk_call.empty())
        stk_call.top().timeCost_+= evit->time_-stk_call.top().timeBlockBegin_;
      if (evit->bOperation_) stk_sOper.push(evit->csName_);
      stk_call.push(TCall(evit->csName_, evit->time_, evit->bOperation_));
    }else{
      TCall& call= stk_call.top();
      call.timeCost_+= evit->time_-call.timeBlockBegin_;
      TMaprofiledInfo& info= map_infos[call.csName_];
      info.csName_= call.csName_;
      info.timeCost_+= call.timeCost_;
      info.timeAll_+= evit->time_-call.timeBegin_;
      ++info.ctCalled_;
      if (call.bOperation_) stk_sOper.pop();
      if (!stk_sOper.empty()){
        TMaprofiledInfo& info2= map2_infos[stk_sOper.top()][call.csName_];
        info2.csName_= call.csName_;
        info2.timeCost_+=
          (call.bOperation_? evit->time_-call.timeBegin_:call.timeCost_);
        info2.timeAll_+= evit->time_-call.timeBegin_;
        ++info2.ctCalled_;
      }
      stk_call.pop();
      if (!stk_call.empty())
        stk_call.top().timeBlockBegin_= evit->time_;
    }
  }
  //͌ʂo
  ofstream fsProf((sFile_+".txt").c_str());
  PrintInfos(fsProf, map_infos, timeWhole, lenMaxName);
  for (TInfoMapMap::const_iterator mpit= map2_infos.begin();
      mpit!=map2_infos.end(); ++mpit){
    fsProf<<endl<<'['<<(mpit->first)<<']'<<endl;
    PrintInfos(fsProf, mpit->second, map_infos[mpit->first].timeAll_,
      lenMaxName);
  }
}

//---------------------------------------------------------------------------
//TInfoMapɏo͂
void TMaprof::PrintInfos(std::ostream& os, const TInfoMap& mp,
  double timeWhole, int lenMaxName)
{
  TInfos infos;
  double timeElse= timeWhole;
  for (TInfoMap::const_iterator ifit= mp.begin(); ifit!=mp.end(); ++ifit){
    infos.push_back(ifit->second);
    timeElse-= ifit->second.timeCost_;
  }
  TMaprofiledInfo infoElse("(Else)");
  infoElse.timeCost_= infoElse.timeAll_= timeElse;
  infos.push_back(infoElse);
  sort(infos.begin(), infos.end());
  for (TInfos::reverse_iterator ifit= infos.rbegin();
      ifit!=infos.rend(); ++ifit){
    os<<setw(lenMaxName)<<left<<(ifit->csName_)<<right
      <<' '<<fixed<<setprecision(3)<<setw(8)<<(ifit->timeCost_)
      <<'('<<setw(3)<<int(ifit->timeCost_/timeWhole*100+0.5)
      <<"%) "<<fixed<<setprecision(3)<<setw(8)<<(ifit->timeAll_)
      <<'('<<setw(3)<<int(ifit->timeAll_/timeWhole*100+0.5)
      <<"%) "<<setw(6)<<(ifit->ctCalled_);
    if (ifit->ctCalled_>0)
      os<<"  "<<scientific<<setprecision(3)
        <<(ifit->timeCost_/ifit->ctCalled_);
    os<<endl;
  }
}

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif //GIMITE_MAPROF
//---------------------------------------------------------------------------

