//---------------------------------------------------------------------------
/*
                 Copy-on-write xN^  cow_vector  Ver.1.0


                                    Gimite s <gimite@mx12.freecom.ne.jp>

*/
//---------------------------------------------------------------------------
#ifndef GIMITE_ass_vectorH
#define GIMITE_ass_vectorH
//---------------------------------------------------------------------------
#include <cassert>
#include <vector>
#include <boost/shared_ptr.hpp>
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
template <class T, class Allocator= std::allocator<T> >
class cow_vector
{
  typedef std::vector<T, Allocator> vector_t;
  typedef boost::shared_ptr<vector_t> vector_ptr_t;
  
public:
  typedef typename vector_t::reference reference;
  typedef typename vector_t::const_reference const_reference;
  typedef typename vector_t::size_type size_type;
  
  class proxy
  {
  public:
    explicit proxy(cow_vector& v, size_type p): vec_(v), pos_(p){}
    operator const_reference()const{ return vec_.get(pos_); }
    template <class S>
    proxy& operator=(const S& rhs){
      vec_.set(pos_, rhs);
      return *this;
    }
    
  private:
    cow_vector& vec_;
    size_type pos_;
    
  };

  explicit cow_vector(const Allocator& alloc= Allocator())
    : ptr_(new vector_t(alloc)){}
  explicit cow_vector (size_type size, const T& val= T(), 
      const Allocator& alloc= Allocator())
    : ptr_(new vector_t(size, val, alloc)){}
  template <class InputIterator>
  cow_vector (InputIterator first, InputIterator last, 
      const Allocator& alloc= Allocator ())
    : ptr_(new vector_t(first, last, alloc)){}
  
  proxy operator[](size_type pos){
    return proxy(*this, pos);
  }
  const_reference operator[](size_type pos)const{
    return get(pos);
  }
  /*
  reference back(){
    assert(this->size() > 0);
    return base_t::back();
  }
  const_reference back()const{
    assert(this->size() > 0);
    return base_t::back();
  }
  iterator erase(iterator pos){
    assert(pos >= this->begin() && pos < this->end());
    return base_t::erase(pos);
  }
  iterator erase(iterator first, iterator last){
    assert(this->begin() <= first && first<=last && last <= this->end());
    return base_t::erase(first, last);
  }
  reference front(){
    assert(this->size() > 0);
    return base_t::front();
  }
  const_reference front()const{
    assert(this->size() > 0);
    return base_t::front();
  }
  iterator insert(iterator pos, const T& x){
    assert(pos >= this->begin() && pos <= this->end());
    return base_t::insert(pos, x);
  }
  void insert(iterator pos, size_type n, const T& x){
    assert(pos >= this->begin() && pos <= this->end());
    base_t::insert(pos, n, x);
  }
  template <class InputIterator>
  void insert(iterator pos, InputIterator first, InputIterator last){
    assert(pos >= this->begin() && pos <= this->end());
    base_t::insert(pos, first, last);
  }
  void pop_back(){
    assert(this->size() > 0);
    base_t::pop_back();
  }
  */
  
  const_reference get(size_type pos)const{ (*ptr_)[pos]; }
  template <class S>
  void set(size_type pos, const S& val){
    if (!ptr_.unique())
      ptr_.reset(new vector_t(*ptr_));
    (*ptr_)[pos]= val;
  }
  
private:
  vector_ptr_t ptr_;

};

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
