//---------------------------------------------------------------------------
/*
                    temp_array Ver.1.0  by Gimite

*/
//---------------------------------------------------------------------------
#ifndef GIMITE_temp_arrayH
#define GIMITE_temp_arrayH
//---------------------------------------------------------------------------
#include <cassert>
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
template <class T>
class temp_array
{
public:
	typedef T* iterator;
	typedef const T* const_iterator;
	
	explicit temp_array(int sz): size_(sz), buf_(new T[sz]){}
  ~temp_array(){ delete[] buf_; }
	
	T& operator[](int n){
		assert(n>=0 && n<size_);
		return buf_[n];
	}
	
	const T& operator[](int n) const{
		assert(n>=0 && n<size_);
		return buf_[n];
	}
	
	iterator begin(){ return buf_; }
	const_iterator begin()const{ return buf_; }
	iterator end(){ return buf_+size_; }
	const_iterator end()const{ return buf_+size_; }
	
	T* get(){ return buf_; }
	const T* get()const{ return buf_; }
	
	int size(){ return size_; }

private:
  int size_;
  T* buf_;
	
};

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
